# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define section free

%bcond_without repolib

%define reltag redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           wss4j
Version:        1.6.5
Release:        6.%{?reltag}%{?dist}
Epoch:          0
Summary:        Implementation of the OASIS Web Services Security
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://ws.apache.org/wss4j/
%if 0
svn export http://svn.apache.org/repos/asf/webservices/wss4j/tags/1_6_5/ wss4j-1.6.5
Exported revision 1305210
tar -cjf wss4j-1.6.5.tar.bz2 wss4j-1.6.5/
%endif
Source0:        wss4j-1.6.5.tar.bz2
Source1:        wss4j-jpp-depmap.xml
Patch0:         wss4j-vman-pom.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

Requires:       xml-security
Requires:       jakarta-commons-logging
#Optional:       opensaml
Requires:       xalan-j2
Requires:       xerces-j2
# xml-commons-jaxp-1.3-apis is provided by the JDK
#Requires:       xml-commons-jaxp-1.3-apis

BuildRequires:  xml-security
BuildRequires:  jakarta-commons-logging
BuildRequires:  opensaml
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
#BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  junit4
BuildRequires:  slf4j
BuildRequires:  log4j
BuildRequires:  xml-commons-resolver
BuildRequires:  apache-jar-resource-bundle >= 0:1.4
BuildRequires:  bouncycastle
BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-bundle-plugin

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description 
Apache WSS4J is an implementation of the OASIS Web Services Security
(WS-Security) from OASIS Web Services Security TC. WSS4J is a
primarily a Java library that can be used to sign and verify SOAP
Messages with WS-Security information. WSS4J will use Apache Axis and
Apache XML-Security projects and will be interoperable with JAX-RPC
based server/clients and .NET server/clients.

Note: To use with axis, bouncycastle, and opensaml, please add the jar to
the Classpath.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for wss4j
Requires:       jpackage-utils

%description javadoc
Javadoc for wss4j.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 

find -type f -name "*.jar" | xargs -t rm

# Copy crypto.properties to a location that is searched
mkdir -p target/test-classes
cp -p src/test/resources/crypto.properties target/test-classes

%build
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven2.jpp.depmap.file=%{SOURCE1} -Dmaven.test.failure.ignore=true source:jar javadoc:aggregate-jar deploy javadoc:aggregate

%install
%{__rm} -rf %{buildroot}

# create an empty MANIFEST.MF
cat > MANIFEST.MF << EOT

EOT
# update & correct the MANIFEST.MF in jar to have a blank end line
# this fix JBPAPP-9192, empty MANIFEST.MF in signed jars
jar ufm target/wss4j-%{namedversion}.jar MANIFEST.MF

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
#%{__cp} -p target/wss4j-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/wss4j-%{namedversion}-javadoc.jar
%{__cp} -p target/wss4j-%{namedversion}-sources.jar %{buildroot}%{_javadir}/wss4j-%{namedversion}-sources.jar
%{__cp} -p target/wss4j-%{namedversion}.jar %{buildroot}%{_javadir}/wss4j-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/org/apache/ws/security/wss4j/%{namedversion}/wss4j-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-wss4j.pom

# depmaps
%add_to_maven_depmap org.apache.ws.security wss4j %{namedversion} JPP wss4j
[ -f %{buildroot}%{_mavendepmapfragdir}/wss4j ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/wss4j

# javadoc
%{__mkdir_p} %{buildroot}/%{_javadocdir}/wss4j-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}/%{_javadocdir}/wss4j-%{namedversion}
%{__ln_s} wss4j-%{namedversion} %{buildroot}/%{_javadocdir}/wss4j

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
rm -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/apache/ws/security/wss4j/%{namedversion}/%{name}-%{namedversion}.pom*
rm -rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/apache/ws/security/wss4j/%{namedversion}/%{name}-%{namedversion}.jar*
mvn-jpp -e \
    deploy:deploy-file \
    -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{name}.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}-%{namedversion}.jar \
    -Durl=file://%{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/ \
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc ChangeLog.txt LICENSE.txt NOTICE README.txt
#%{_javadir}*/wss4j-%{namedversion}-javadoc.jar
#%{_javadir}*/wss4j-javadoc.jar
%{_javadir}*/wss4j-%{namedversion}-sources.jar
%{_javadir}*/wss4j-sources.jar
%{_javadir}*/wss4j-%{namedversion}.jar
%{_javadir}*/wss4j.jar
%{_mavenpomdir}/JPP-wss4j.pom
%{_mavendepmapfragdir}/wss4j

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/wss4j-%{namedversion}
%{_javadocdir}/wss4j

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jun 12 2012 Fernando Nasser <fnasser@redhat.com> 0:1.6.5-6.redhat_1
- Make opensaml optional again (DO NOT RE-ADD PLEASE)

* Thu May 31 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.6.5-5.redhat_1
- Remove javadocs from main package

* Thu May 31 2012 Hui Wang <huwang@redhat.com> - 0:1.6.5-4.redhat_1
- Fix repolib

* Thu May 31 2012 Hui Wang <huwang@redhat.com> - 0:1.6.5-3.redhat_1
- Fix JBPAPP-9192, blank manifest in EAP build

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.5-2.redhat_1
- Remove depenecy on xml-commons-jaxp-1.3-apis 

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.5-1_redhat_1.1.1
- Rebuild using cache signing

* Mon Mar 26 2012 Hui Wang <huwang@redhat.com> 0:1.6.5-1_redhat_1.1
- Upgrade to 1.6.5

* Thu Mar 15 2012 Fernando Nasser <fnasser@redhat.com> 0:1.6.4-1_redhat_1.1
- Make opensaml optional

* Tue Feb 21 2012 Hui Wang <huwang@redhat.com> 0:1.6.4-1_redhat_1
- Upgrade to 1.6.4

* Fri Feb 03 2012 David Walluck <dwalluck@redhat.com> 0:1.6.3-3
- replace commons-logging by jcl-over-slf4j
- fix Requires
- add docs
- fix sources jar
- fix repolib file list
- reduce BuildRequires list
- use newer felix stack
- javadoc requires jpackage-utils

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 0:1.6.3-2_redhat_1
- Build for Werewolf
- Build with maven only

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 0:1.6.3-1
- Upgrade to 1.6.3

* Sat Oct 01 2011 Yong Yang <yyang@redhat.com> 0:1.6.1-2
- Remove binary repo

* Sun Sep 26 2011 Yong Yang <yyang@redhat.com> 0:1.6.1-1
- Upgrade to 1.6.1

* Wed Jun 8 2011 Yong Yang <yyang@redhat.com> 0:1.5.11-1
- Upgrade to 1.5.11

* Tue Jun 7 2011 Yong Yang <yyang@redhat.com> 0:1.5.10-3_patch_01.1
- Build for EAP6

* Mon Jun 6 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.5.10-3_patch_01
- Patch pom.xml to have version 1.5.10_patch_01
- Modify spec file so that jars have -patch-01 in their versions

* Fri Jun 3 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.5.10-1.patch_01.1
- Upgrade to 1.5.10
- Apply wss4j-security.patch (JBPAPP-6642)
- Modify wss4j-1.5.8-build.patch

* Wed Jan 12 2011 Yiqiao Wang <yiwang@redhat.com> 0:1.5.8-8
- Comment BR and R ws-fx-addressing

* Thu Dec 02 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.5.8-7
- Rebuild to fix upload.sh

* Wed Dec 01 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.5.8-6
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew
- Add BR mavne-deploy-plugin and maven-shared-artifact-resolver

* Tue Jun 29 2010 Permaine Cheung <pcheung@redhat.com> 0:1.5.8-5
- Mark axis as Optional Requires

* Mon Jun 28 2010 Permaine Cheung <pcheung@redhat.com> 0:1.5.8-4
- Mark bouncycastle and opensaml as Optional Requires

* Mon Jun 07 2010 David Walluck <dwalluck@redhat.com> 0:1.5.8-3
- enable maven-remote-resources-plugin

* Mon Jun 07 2010 David Walluck <dwalluck@redhat.com> 0:1.5.8-2
- fix build

* Wed Jun 02 2010 Fernando Nasser fnasser@redhat.com> 0:1.5.8-1
- Upgrade to 1.5.8
- Upgrade build to maven2

* Wed Dec 09 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.7-2
- Add BR glassfish-jaf, glassfish-javamail
- Fix repolib location
- Uncomment project.patch, to use the current project version
- Add pom.xml to repolib
- Add fix for failing test copying crypto.properties to a proper location
- Add sources jar file to main package and repolib

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.7-1
- Upgrade to 1.5.7
- Comment 1.5.3 patches
- Change (B)R bouncycastle-provider to bouncycastle
- Add repolib

* Fri Jul 24 2009 Martha Benitez <mbenitez@redhat.com> 0:1.5.3-1.1
- Adjust release tag
- Change jpackage-utils >= 0:1.7.4 to jpackage-utils >= 0:1.7.3
- Comment out: java-1.5.0-sun-jce-policy, bouncycastle-provider
- Add build-classpath junit

* Fri Mar 28 2008 Ralph Apel <r.apel at r-apel.de> 0:1.5.3-1jpp
- 1.5.3
- Drop ws-commons-policy and ws-commons-neethi (B)Rs
- Build with maven1 by default

* Wed Oct 10 2007 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-3jpp
- (B)R bouncycastle-provider instead of bouncycastle-jdk1.X
- (B)R ws-commons-neethi, as a way of avoiding usage of old neethi
  package to satisfy ws-commons-policy (B)R

* Wed Jul 11 2007 Ralph Apel <r.apel at r-apel.de> 0:1.5.0-2jpp
- Replace neethi (B)R by ws-commons-policy

* Wed May 24 2006 Deepak Bhole <dbhole@redhat.com> 0:1.5.0-1jpp
- Upgrade to 1.5.0

* Mon Jan 16 2006 Deepak Bhole <dbhole@redhat.com> 0:1.1.1-0.20060117.1jpp
- Upgrade to 1.1.1 snapshot

* Thu Oct 20 2005 Deepak Bhole <dbhole@redhat.com> 0:1.1.0-1jpp
- Initial build.
